
	LIST	p=16F88		
	include "P16F88.inc"		
	ERRORLEVEL	0,	-302	

	__CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_IO

	__CONFIG    _CONFIG2, _IESO_OFF & _FCMEN_OFF

LCD_PORT	Equ	PORTB
LCD_TRIS	Equ	TRISB
LCD_RS		Equ	0x04			;LCD Stuff
LCD_RW		Equ	0x06
LCD_E		Equ	0x07

	

	CBLOCK 0x20
	sec
	sec10
	min
	min10
	hr
	hr10
	bres_hi ; hi byte of 24bit variable
	bres_mid ; mid byte of 24bit variable
	bres_lo ; lo byte of 24bit variable


	status_temp 

	templcd 
	templcd2
	count 
	count1 
	counta 
	countb 
	oldtime
	ENDC

	CBLOCK 0x70
	w_temp          
	ENDC


	org 0x000 		
	goto setup			

	org 0x004				
	goto int_handler

setup					


	 movlw   B'01100000' 
    banksel OSCCON        ; Setting up OSCCON for 4mhz
    movwf   OSCCON 
    banksel	0

lp 
  btfss   OSCCON, 2    
    goto    lp 
    
		
	movlw b'00001000'		
	banksel OPTION_REG	;Setting up Option Reg.  Prescaler set to WDT just to keep it off of Timer0	
	movwf OPTION_REG		
	banksel 0				
	
	clrf PORTB			
						
	movlw b'00000000'	
						
	banksel TRISB			
	movwf TRISB			
	banksel 0				
							
	clrf PORTA			
	movlw b'00000000'		
	banksel TRISA		
	movwf TRISA			
	banksel 0				

	movlw b'11100000'
	banksel 	INTCON    ;Set up INTCON
	movwf INTCON
	banksel	0
	clrf	sec
	clrf	sec10
	clrf	min
	clrf	min10
	clrf	hr
	clrf	hr10
	
						
	movlw 0x0F			 
	movwf bres_hi			
	movlw 0x42 +1		;Loading 24 bit variable with 1,000,000	
	movwf bres_mid			
	movlw 0x40			
	movwf bres_lo			
		
	goto main				

int_handler	
			
	movwf w_temp      	
	movf	STATUS,w          	
	movwf status_temp       	
						
	tstf bres_mid			
	skpnz				
	decf bres_hi,f		
	decfsz bres_mid,f		; dec the mid byte (subtract 256)
	goto int_exit			

	tstf bres_hi			
	skpz					
	goto int_exit			

	

	movlw 0x0F			
	movwf bres_hi		

	movlw 0x42			;24 bit variable value <256 add 1,000,000 and increase sec
	movwf bres_mid			

	movlw 0x40			
	addwf bres_lo,f		
	skpnc				

	incf bres_mid,f		
						

            movlw sec                
            movwf FSR
newdigit:   incf INDF, f             
            movlw sec          ;Increase sec and any other that will changed because of sec increase       
            subwf FSR, W
            call sethi              
            subwf INDF, W            
            btfss STATUS, Z          
            goto int_exit            
            clrf INDF                
            incf FSR, f              
            goto newdigit            
	
int_exit
			BCF INTCON,2
			bcf	STATUS,Z		
			movf status_temp,w     	
			movwf STATUS            	
			swapf w_temp,f
			swapf w_temp,w          
	
	retfie			

;------------------------------------------------------------------------------
;-------------------------------------------------------------------------;
;                      High limit + 1 of digits at position W             ;
;-------------------------------------------------------------------------;
sethi:
            addwf PCL, f
         dt H'A',H'6',H'A',H'6',H'A',H'A'


LCD_Init	call	Delay100		

		movlw	0x20			
		call	LCD_Cmd

		movlw	0x28			
		call	LCD_Cmd

		movlw	0x06			
		call	LCD_Cmd

		movlw	0x0c			
		call	LCD_Cmd			

		call	LCD_Clr			

		retlw	0x00

LCD_Cmd	
		movwf	templcd
		swapf	templcd,	w		
		andlw	0x0f		
		movwf	LCD_PORT
		bcf	LCD_PORT, LCD_RS	
		call	Pulse_e			
		movf	templcd,	w	
		andlw	0x0f			
		movwf	LCD_PORT
		bcf	LCD_PORT, LCD_RS	
		call	Pulse_e			
		call 	Delay5
		retlw	0x00

LCD_CharD	addlw	0x30		
LCD_Char	movwf	templcd
		swapf	templcd,	w	
		andlw	0x0f			
		movwf	LCD_PORT
		bsf	LCD_PORT, LCD_RS	
		call	Pulse_e			

		movf	templcd,	w	
		andlw	0x0f			
		movwf	LCD_PORT
		bsf	LCD_PORT, LCD_RS	
		call	Pulse_e			
		call 	Delay5
		retlw	0x00

LCD_Line1	movlw	0x80			
		call	LCD_Cmd
		retlw	0x00

LCD_Line2	movlw	0xc0		
		call	LCD_Cmd
		retlw	0x00

LCD_Line1W	addlw	0x80			
		call	LCD_Cmd
		retlw	0x00

LCD_Line2W	addlw	0xc0			
		call	LCD_Cmd
		retlw	0x00

LCD_CurOn	movlw	0x0d			
		call	LCD_Cmd
		retlw	0x00

LCD_CurOff	movlw	0x0c			
		call	LCD_Cmd
		retlw	0x00

LCD_Clr		movlw	0x01			
		call	LCD_Cmd
		retlw	0x00



Delay255	movlw	0xff		;delay 255 mS
		goto	d0
Delay100	movlw	d'100'		;delay 100mS
		goto	d0
Delay50		movlw	d'50'		;delay 50mS
		goto	d0
Delay20		movlw	d'20'		;delay 20mS
		goto	d0
Delay5		movlw	0x05		;delay 5.000 ms (4 MHz clock)
d0		movwf	count1
d1		movlw	0xC7			;delay 1mS
		movwf	counta
		movlw	0x01
		movwf	countb
Delay_0
		decfsz	counta, f
		goto	$+2
		decfsz	countb, f
		goto	Delay_0

		decfsz	count1	,f
		goto	d1
		retlw	0x00

Pulse_e		bsf	LCD_PORT, LCD_E
		nop
		bcf	LCD_PORT, LCD_E
		retlw	0x00



DispTime
              MOVLW 0x04
              CALL LCD_Line1W
             movf hr10,w
              CALL LCD_CharD
             movf	 hr,w
              CALL LCD_CharD
              MOVLW ":"
              CALL LCD_Char
              movf	min10,w
              CALL LCD_CharD
             movf	 min,w
              CALL LCD_CharD
              MOVLW ":"
              CALL LCD_Char
              movf sec10,w
              CALL LCD_CharD
              movf sec,w
              CALL LCD_CharD
              RETURN
main						

	call LCD_Init
	
main_loop					 
	   movf oldtime, W         
       subwf sec, W
       btfsc STATUS, Z      ;If sec different from oldtime DispTime else loop to next int   
       goto main_loop          
       call DispTime           
       movf sec, W             
       movwf oldtime
	   goto main_loop		


	end				
